package com.googlecode.mapperdao

/**
 * A simple entity is an entity that doesn't have an autogenerated key. Typically an entity with
 * a natural key is a SimpleEntity. I.e. Product(refCode,title) where refCode is the natural key
 * should be mapped with ProductEntity extends SimpleEntity[Product].
 *
 * The table name can be provided if it doesn't match the default naming convention.
 */
abstract class SimpleEntity[T](table: String, clz: Class[T]) extends Entity[AnyRef, T](table, clz) {
	def this()(implicit m: ClassManifest[T]) = this(m.erasure.getSimpleName, m.erasure.asInstanceOf[Class[T]])
	def this(table: String)(implicit m: ClassManifest[T]) = this(table, m.erasure.asInstanceOf[Class[T]])
}
